#!/usr/bin/env python3
# Copyright (c) Facebook, Inc. and its affiliates. All Rights Reserved
from typing import Dict, List, Optional, Union

from pytext.common.constants import DatasetFieldName

from pytext.config.field_config import DocLabelConfig, TargetConfigBase, WordLabelConfig

from pytext.data.tensorizers import Tensorizer
from pytext.exporters import DenseFeatureExporter
from .compositional_metric_reporter import CustomMetricReporter
from pytext.models.model import Model


from pytext.task import Task
from pytext.trainers import HogwildTrainer, Trainer
from pytext.utils import distributed

from pytext.config.component import (
    create_component,
    create_data_handler,
    create_exporter,
    create_featurizer,
    create_metric_reporter,
    create_model,
    create_trainer,
)
from .rnng_parser import *

from pytext.fields import FieldMeta
from .compositional_data_handler import CustomDataHandler
from pytext.utils import cuda


    


class MedExtTask(Task):
    class Config(Task.Config):
        model: RNNGner.Config = RNNGner.Config()
        trainer: HogwildTrainer.Config = HogwildTrainer.Config()
        data_handler: CustomDataHandler.Config = CustomDataHandler.Config()
        labels: Optional[WordLabelConfig] = None
        metric_reporter: CustomMetricReporter.Config = CustomMetricReporter.Config()
        save_module_checkpoints:bool = False
    
    @classmethod
    def from_config(
        cls, task_config = Config, metadata=None, model_state=None, rank=1, world_size=0
    ):
        """
        Create the task from config, and optionally load metadata/model_state
        This function will create components including :class:`~DataHandler`,
        :class:`~Trainer`, :class:`~MetricReporter`,
        :class:`~Exporter`, and wire them up.
        Args:
            task_config (Task.Config): the config of the current task
            metadata: saved global context of this task, e.g: vocabulary, will be
                generated by :class:`~DataHandler` if it's None
            model_state: saved model parameters, will be loaded into model when given
        """
        if hasattr(task_config.labels, "target_prob"):
            assert task_config.labels.target_prob == isinstance(
                task_config.model.output_layer.loss,
                (
                    KLDivergenceBCELoss.Config,
                    KLDivergenceCELoss.Config,
                    SoftHardBCELoss.Config,
                ),
            ), "target_prob must be set to True for KD losses"
        featurizer = create_featurizer(task_config.featurizer, task_config.features)
        # load data
        task_config.data_handler.beam_size = task_config.model.beam_size
        task_config.data_handler.top_k = task_config.model.top_k
        
        if task_config.model.ablation.use_elmo:
            pretrained_path = task_config.features.word_feat.pretrained_embeddings_path
            task_config.features.word_feat.pretrained_embeddings_path = ""


        data_handler = CustomDataHandler.from_config(
            task_config.data_handler,
            task_config.features,
            task_config.labels,
            featurizer=featurizer
        )
        print("\nLoading data...")
        if metadata:
            data_handler.load_metadata(metadata)

        else:
            data_handler.init_metadata()

        metadata = data_handler.metadata
        
        if task_config.model.ablation.use_elmo:
            task_config.features.word_feat.pretrained_embeddings_path = pretrained_path
            
        model = RNNGner.from_config(task_config.model, task_config.features, metadata,  torch.device("cuda" if cuda.CUDA_ENABLED else "cpu"))


        if model_state:
            model.load_state_dict(model_state)


        metric_reporter = CustomMetricReporter.from_config(task_config.metric_reporter, metadata)
        exporter = (
            create_exporter(
                task_config.exporter,
                task_config.features,
                task_config.labels,
                data_handler.metadata,
                task_config.model,
                task_config.featurizer,
            )
            if task_config.exporter
            else None
        )
        
        task_config.trainer.real_trainer.report_train_metrics = False
        task_config.trainer.save_module_checkpoints = task_config.save_module_checkpoints
        trainer=create_trainer(task_config.trainer, model)
        
        return cls(
            trainer=trainer,
            data_handler=data_handler,
            model=model,
            metric_reporter=metric_reporter,
            exporter=exporter
        )